//
//  Connection.swift
//  UniPayI_V_Test_App
//
//  Created by IDTech on 7/14/16.
//  Copyright © 2016 IDTech. All rights reserved.
//

import UIKit

class Connection: NSObject {
    var connectionStatus = "Disconnected"
    var backgroundColor = UIColor.red
    var resultsText = ""
    var dataText = ""
    var autoAuthenticateStatus = true
    var autoCompleteStatus = true
    var stressTestEMVLoopStatus = false
    
    func setTheStatus(_ status: String) {
        self.connectionStatus = status
    }
    
    func setTheBackgroundColor(_ color: UIColor) {
        self.backgroundColor = color
    }
    
    func setTheResultsText(_ text: String) {
        self.resultsText = text;
    }
    
    func setTheDataText(_ text: String) {
        self.dataText = text
    }
    
    func setTheAutoAuthenticateStatus(_ status: Bool) {
        self.autoAuthenticateStatus = status
    }
    
    func setTheAutoCompleteStatus(_ status: Bool) {
        self.autoCompleteStatus = status
    }
    
    func setTheStressTestEMVLoopStatus(_ status: Bool) {
        self.stressTestEMVLoopStatus = status
    }
    
    func getTheStatus() -> String {
        return self.connectionStatus
    }
    
    func getTheBackgroundColor() -> UIColor {
        return self.backgroundColor
    }
    
    func getTheResultsText() -> String {
        return self.resultsText
    }
    
    func getTheDataText() -> String {
        return self.dataText
    }
    
    func getTheAutoAuthenticateStatus() -> Bool {
        return self.autoAuthenticateStatus
    }
    
    func getTheAutoCompleteStatus() -> Bool {
        return self.autoCompleteStatus
    }
    
    func getTheStressTestEMVLoopStatus() -> Bool {
        return self.stressTestEMVLoopStatus
    }
    
    func appendMessageToResultsField(_ message: String, field: UITextView) {
        self.setTheResultsText("\(self.getTheResultsText())\n\(message)\n")
        
        field.text = self.getTheResultsText()
       // field.scrollRangeToVisible(NSRange(location: 0, length: 0))
        
       // NotificationCenter.default.post(name: Notification.Name(rawValue: "load"), object: nil)
    }
    
    func appendMessageToDataField(_ message: String, field: UITextView) {
        self.setTheDataText("\(self.getTheDataText())\(message)")
        
        field.text = self.getTheDataText()
       // field.scrollRangeToVisible(NSRange(location: 0, length: 0))
        
        //NotificationCenter.default.post(name: Notification.Name(rawValue: "load"), object: nil)
    }
    
    func displayReturnError(_ operation: String, rt: RETURN_CODE, field: UITextView) {
        let message = "\(operation) ERROR: ID-\(rt.rawValue), Message: \(IDT_UniPayI_V.sharedController().device_getResponseCodeString(Int32(rt.rawValue)))"
        
        self.appendMessageToResultsField(message, field: field)
    }
    
    func clearOutputs(_ resultsTextView: UITextView, dataTextView: UITextView) {
        self.setTheResultsText("")
        self.setTheDataText("")
        
        resultsTextView.text = self.getTheResultsText()
        dataTextView.text = self.getTheDataText()
        
        NotificationCenter.default.post(name: Notification.Name(rawValue: "load"), object: nil)
    }
}
